TEXTBLOCK RUNDEMO.PRG

    /* This program is a demonstration of how to run programs from within VO. There are several ways to do
	 this. The ones I have demonstrated here, are the WINEXEC() API function, and the APP:RUN method
	 of the class APP. If you have the book WINDOWS API BIBLE (a great source for Windows API
	 information), you can find all the info on WINEXEC() on page 665. If you have access to 
	MS Visual Basic, it has a help file with all of the API information as well.
	
	Also, the program demonstrates how to create a window from scratch, and how to create a
	 warning box (all things I needed to learn)!
	
	You may want to replace the program names that I used to ones that are one your system, or run it as
	 is and watch it crash!
	 
	You MUST include the System Classes, Widows API, and GUI Classes in the Application Properties
	 to compile this application.
	
	I hope you find this information useful.	If you have questions, feel free to ask me on the VOFORUM
	or e-mail me. I'm not saying this is the best code, but maybe it will give you ideas. If you have
	comments/criticisms/witicisims about the code, I'd be glad to look at them.	Thanks.
	Tom Hannum CIS:71162,513    */
	
FUNCTION MakeNoise   // this just makes some noise 
 LOCAL x AS WORD
 
 FOR x = 375 TO 1500 STEP 25
  TONE(x,.1)
 NEXT
 //  notice, you don't need a return from a function if you're not returning a value
CLASS TchWin INHERIT TopAppWindow
/* Set up my class to inherit from the class TopAppWindow (a window class).
    This allows you to draw a window. */
Method RunMyApp CLASS app			// this method runs some programs

LOCAL cProgram := "C:\windows\word6\winword.exe" AS STRING	// the program to run via WinExec
LOCAL nRunError	// The error return code for the APP:RUN method (there are 32 possible error codes)
        
	/*This next line runs a windows application full screen. Even when this program ends,
	    the spawned task continues! This is the APP:RUN method.
	    The APP:RUN always runs the application full screen. */
	    
	nRunError := SELF:RUN("C:\windows\excel\excel.exe")	// put in the name of a program to run
	DO CASE
	 CASE nRunError == 0
	 	// windows error: out of memory
	 CASE nRunError == 2
	 	// windows error: file not found
	 CASE nRunError == 3
		// windows error: path not found	
	 OTHERWISE
	 	// successful run (other errors aren't critical)
	ENDCASE
  	
	/* 	Next is the Windows API call to start a program. The first parameter is the program to run,
		 and the second parameter is how to run it (what mode).	In the VO Windows API Library,
		 in the Module Windows(defines),	 you can find the defines to see how to launch a program.
		 SW_SHOWMAXIMIZED runs the program maximized, making it the top window,
		 SW_MINIMIZE will start an application minimized, SW_SHOWMINIMIZED will start the
		application minimized, but show the icon on top of everything.
		There are 10 different ways to start a windows application (see Windows API Bible, page 666). */
		
	WinExec(STRING2PSZ(cProgram),SW_SHOWMINIMIZED)
	// WinExec requires you send it a PSZ string as a parameter, so I converted it on the fly.
	
	// This next line would run a dos application throught the use of a .pif file
	// SELF:RUN("finance.pif") 	// the pif would determine if the app was run full screen or minimized.
	
	/* Note: I didn't have to code in the full path of the programs I wanted to run.
	    The program search order for windows is:
		1. The current directory
		2. The Windows directory
		3. The Windows SYSTEM directory
		4. The PATH
		5. The network path
	*/	
	
METHOD Start() CLASS App
Local oWin as Window
		
	oWin := TchWin{SELF}	// call the init method for the window
		
	oWin:MyWarn()		// display a warning box (I wanted to figure out how to do this, so here it is!)
                                                        // you must close the warning box before you can move on, its modal!
                                                        
	SELF:RunMyApp()		// call the method RunMyApp
	
	SELF:Exec() 			 // start the event processor loop
                  
	/* After all the programs are run/loaded, you have to close the window we created by clicking
	    the left control, and select close!  After you close the window, this will happen! */
	    
	MakeNoise()
	
Method Init(oOwnerApp) CLASS TchWin	// this initializes the window!
	LOCAL nLeft 	:= 50 AS Int			// the left edge of the window
	LOCAL nBottom := 100 AS Int		// the right edge of the window
	LOCAL nWidth 	:= 500 AS Int		// the width of the window
	LOCAL nHeight 	:= 200 AS Int		// the height of the window
	LOCAL pTextHere AS Point			// needed for the text co-ordinates
									// Note: 0,0 is lower left hand corner of the Window!!!
		
	SUPER:INIT(oOwnerApp)			// Init the parent class		
	SELF:Caption	:="My Test Window"				// add a caption to the window
	SELF:Origin 	:= Point{nLeft,nBottom}				// draw the window starting at this point
	SELF:Size 	:= Dimension{nWidth,nHeight}		// draw the window this size
	pTextHere	:= Point{100,100} 					// create the point at which the text will be printed
	SELF:Show()									// show the window
	SELF:TextPrint("Close the Window to End The Application",pTextHere)	// print the text on the window!
	
Method MyWarn CLASS TchWin
	Local oWin AS OBJECT
	oWin := WarningBox{SELF,"Box Caption","Box Message"}	// Modal!
	oWin:Show()	// show the warning box and wait for a response